// DirEval.prg - Evaluate a directory and optional subdirs

#include "Directry.ch"
#include "Default.ch"

#define TRUE  (.T.)
#define FALSE (.F.)

PROCEDURE DirEval( bBlock, cFileSpec, cAttrs, lSubDirs, cPath )
   LOCAL aDir, aSubDirs:= {}, nSubDirs, i
   DEFAULT cFileSpec TO "*.*"      // All Files by default.
   DEFAULT cAttrs    TO ""         // Additional attributes.
   DEFAULT lSubDirs  TO FALSE      // Don't process subdirs?
   DEFAULT cPath     TO ""         // Starting directory.

   IF ( RAT ( "\", cPath ) <> LEN( cPath ) )
      cPath+= "\"
   ENDIF

   aDir := DIRECTORY(cPath+cFileSpec, cAttrs + IIF( lSubDirs,"D", "") )
   AEVAL(aDir,{|f|EvaluteFiles(f,bBlock,cPath, @aSubDirs,lSubDirs) } )
   nSubDirs := LEN( aSubDirs )
   FOR i := 1 TO nSubDirs
      DirEval( bBlock, cFileSpec, cAttrs, lSubDirs, cPath + ;
         aSubDirs[ i ][ F_NAME ] )
   NEXT
   RETURN

STATIC PROCEDURE EvaluteFiles( aFile, bBlock, cPath, aSubDirs, lSubDirs )
   IF !( Left( aFile[ F_NAME ], 1 ) == "." )           // If not"." or ".."
      IF ( lSubDirs ).AND.( "D" $ aFile[ F_ATTR ] )    // If adirectory
         AADD( aSubDirs, aFile )                       // Add to list
      ENDIF                                            // of subdirs
      EVAL( bBlock, aFile, cPath )                     // Evaluate
   ENDIF
   RETURN

// EOF: Directry.prg
