// Network.prg

#command REPEAT       => WHILE (.T.)
#command UNTIL <expr> => IF <expr>; EXIT; END; END

#define FALSE (.F.)
#define TRUE  (.T.)
#include "inkey.ch"

FUNCTION NetAttempt( bAction, cAction )
   LOCAL nStop, lSuccess := FALSE, nChoice, cMsg
   REPEAT
      nStop := Seconds()+NetTimeOut() // Seconds at timeout
      REPEAT
   
      IF ( lSuccess := EVAL( bAction ) ) .OR. ( InKey(0.5) > 0 )
         EXIT  // Exit if action successful or user pressed key
      ENDIF
   
      UNTIL ( SECONDS() >= nStop )            // Past time yet?
      IF ( !lSuccess )
         nChoice := Alert( "You cannot obtain a "+ cAction + " at this time.", { "Retry", "Cancel" })
         DO CASE
         CASE ( nChoice == 1 )
            LOOP                              // Try, try again
         CASE ( LASTKEY() == K_ESC ) .OR. ( nChoice == 2 )
            BREAK                             // Give it up
         ENDCASE
      ENDIF
   UNTIL ( lSuccess )

   RETURN( lSuccess )

FUNCTION NetTimeOut( nNewTime )
   STATIC nWaitSecs := 5
   LOCAL nOldTime := nWaitSecs
   IF ( nNewTime <> NIL )
      nWaitSecs := nNewTime
   ENDIF

   RETURN ( nOldTime )

// EOF: Network.prg
